(* main.sml *)

(* main processing *)

structure Main :> MAIN =
struct

open CML

(* val print : string -> unit

   we must mention TextIO somewhere in our program, in order to
   get the correct version of print *)

val print = TextIO.print

(* val sleep : int -> unit *)

fun sleep n = sync(timeOutEvt(Time.fromSeconds n))

(* val consumer : string * int Multicast.port * int * int -> unit *)

fun consumer(name, port, tim, copy) =
      let val recvEvt = Multicast.recvEvt port

          (* val loop : int -> unit *)

          fun loop n = 
                (if n = copy
                 then (spawn(fn () =>
                                  consumer("copy:" ^ name,
                                           Multicast.copy port,
                                           tim, copy));
                       ())
                 else ();
                 print(name ^ " : " ^ Int.toString(sync recvEvt) ^ "\n");
                 sleep tim;
                 loop(n + 1))
      in loop 0 end

(* val main : unit -> unit *)

fun main() =
      let val mCh : int Multicast.mchan = Multicast.mChannel()

          (* val loop : int -> unit *)

          fun loop n =
                case TextIO.inputLine TextIO.stdIn of
                     SOME "\n" => (Multicast.multicast(mCh, n); loop(n + 1))
                   | _         => RunCML.shutdown OS.Process.success
      in spawn(fn () => consumer("first",  Multicast.port mCh, 2, 5));
         spawn(fn () => consumer("second", Multicast.port mCh, 5, 10));
         spawn(fn () => consumer("third",  Multicast.port mCh, 7, 15));
         loop 0
      end

(* val doit : unit -> OS.Process.status *)

fun doit() = RunCML.doit(main, NONE)

end;
